from __future__ import annotations
from typing import TYPE_CHECKING, Dict
from common.database.api.entity._Entity import _Entity
from common.database.api.context.Keys import KEY_DEVICE_ENDPOINT

if TYPE_CHECKING:
    from common.database.api.context.Context import Context
    from common.database.api.context.topology.Topology import Topology
    from common.database.api.context.topology.device.Device import Device

VALIDATORS = {
    'port_type': lambda v: v is not None and isinstance(v, str) and (len(v) > 0),
}

TRANSCODERS = {} # no transcoding applied to attributes

class Endpoint(_Entity):
    def __init__(self, endpoint_uuid : str, parent : 'Device'):
        super().__init__(parent, endpoint_uuid, KEY_DEVICE_ENDPOINT, VALIDATORS, TRANSCODERS)

    @property
    def parent(self) -> 'Device': return self._parent

    @property
    def context(self) -> 'Context': return self.parent.context

    @property
    def context_uuid(self) -> str: return self.parent.context_uuid

    @property
    def topology(self) -> 'Topology': return self.parent.topology

    @property
    def topology_uuid(self) -> str: return self.parent.topology_uuid

    @property
    def device(self) -> 'Device': return self.parent

    @property
    def device_uuid(self) -> str: return self.parent.device_uuid

    @property
    def endpoint_uuid(self) -> str: return self._entity_uuid

    def create(self, port_type : str) -> 'Endpoint':
        self.update(update_attributes={
            'port_type': port_type
        })
        self.parent.endpoints.add(self.endpoint_uuid)
        return self

    def update(self, update_attributes={}, remove_attributes=[]) -> 'Endpoint':
        self.attributes.update(update_attributes=update_attributes, remove_attributes=remove_attributes)
        return self

    def delete(self) -> None:
        self.attributes.delete()
        self.parent.endpoints.delete(self.endpoint_uuid)

    def dump_id(self) -> Dict:
        return {
            'topoId': self.topology.dump_id(),
            'dev_id': self.device.dump_id(),
            'port_id': {'uuid': self.endpoint_uuid},
        }

    def dump(self) -> Dict:
        attributes = self.attributes.get()
        return {
            'port_id': self.dump_id(),
            'port_type': attributes.get('port_type', None),
        }
